# Last modified Information Relaying Specification(LIRS)ѥå  ver.2.01(20001013)
# Copyright (C) 1999-2000 hiya All Rights Reserved.
#
# ѰդƤؿϲ̤ꡣ
#
# ֥ȻظץߥѤΥ᥽å
# use LIRS;
# $obj = new LIRS;
# $obj->tolist(LIRS쥳);
# LIRS쥳ɤLIRSͤ˴Ťʬ򤷤ƥꥹȤȤ֤᥽åɡ
# $obj->toLIRS(, ︡λ, , եĹ, URL, ڡȥ, , , ץ);
# ƹܤLIRSͤ˴Ťʬ򤷤LIRS쥳ɤˤ֤᥽åɡ
# $obj->compressLIRS(gzipץξ, ̤ե);
# ꤷեgzipץǰ̤̤եƱݴɤ᥽åɡ
# $obj->extractLIRS(gzipץξ, हե);
# ꤷե򰵽̥եƱgzipץǲह᥽åɡ
#
# ̾Υ֥롼ȤƻȤ
# use LIRS;
# &LIRS::LIRS2list(LIRS쥳);
# LIRS쥳ɤLIRSͤ˴Ťʬ򤷤ƥꥹȤȤ֤֥롼
# &LIRS::list2LIRS(, ︡λ, , եĹ, URL, ڡȥ, , , ץ);
# ƹܤLIRSͤ˴Ťʬ򤷤LIRS쥳ɤˤ֤᥽åɡ
# &LIRS::cLIRS(gzipץξ, ̤ե);
# ꤷեgzipץǰ̤̤եƱݴɤ᥽åɡ
# &LIRS::xLIRS(gzipץξ, हե);
# ꤷե򰵽̥եƱgzipץǲह᥽åɡ


# 
package LIRS;
require 5.000;
use strict;
use File::Copy;

$LIRS::version = q(2.0);


sub ver{
	return $LIRS::version;
}


#### ֥ȻظץߥѤΥ᥽å

## new
# 󥹥󥹤롣
sub new{
	my $pkg = shift;
	my $obj = bless {}, $pkg;
	return $obj;
}


## tolist
# LIRSΰĤΥ쥳ɤϤȡLIRSǤȤ֤
# ΤȤץʥΥեɤϤޤȤ(,פޤ)֤ΤǡǤʤФʤʤ
sub tolist{
	my ($obj, $rec) = @_;

	unless($rec =~ /^#/){
		$rec =~ s/\\/%5c/g;
		$rec =~ s/%5c%5c/%rr/g;
		$rec =~ s/%5c,/%2c/g;
		$rec =~ s/%rr/\\\\/g;
		$rec =~ s/%5c/\\/g;
		my ($head, $time, $lmd, $lag, $length, $url, $title, $author, $remote, $chksum) = split(",", $rec, 10);
		if($chksum =~ /(\015|\012)+$/ && $head eq "LIRS"){
			$url =~ s/%7e/~/io;

			$url =~ s/%2c/,/ig;
			$title =~ s/%2c/,/ig;
			$author =~ s/%2c/,/ig;
			$chksum =~ s/(.*,)(\015|\012)+$/$1/;
			$chksum =~ s/%2c/\\,/ig;
			return($time, $lmd, $lag, $length, $url, $title, $author, $remote, $chksum);
		}else{
			return 0;
		}
	}else{
		return 0;
	}
}


## toLIRS
# LIRSν¤ϤȡLIRSΰĤΥ쥳ɤˤʤä顼ѿ֤
# ΤȤץʥΥեɤϤޤȤ(,פޤ)Τޤ޸ɵʤΤǡ餫ἫǽƤʤФʤʤ
sub toLIRS{
	my ($obj, $time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional) = @_;
	my $ret;

	$lmd = 0 if($lmd eq "");
	$lag = 0 if($lag eq "");
	$length = 0 if($length eq "");
	$title = 0 if($title eq "");
	$author = 0 if($author eq "");
	$remote = 0 if($remote eq "");

	$url =~ s/\\\\/%rr/g;
	$url =~ s/\\/\\\\/g;
	$url =~ s/%rr/\\\\/g;
	$title =~ s/\\\\/%rr/g;
	$title =~ s/\\/\\\\/g;
	$title =~ s/%rr/\\\\/g;
	$author =~ s/\\\\/%rr/g;
	$author =~ s/\\/\\\\/g;
	$author =~ s/%rr/\\\\/g;
	$url =~ s/,/\\,/g;
	$title =~ s/,/\\,/g;
	$author =~ s/,/\\,/g;

	$remote = "" unless($length =~ /^[\\,\#\&\%\+\.\/\:\=\?\@\w\s\~\-!<>]+$/);
	$time = "" unless($time =~ /^\d+$/);
	$lmd = "" unless($lmd =~ /^\d+$/);
	$lag = "" unless($lag =~ /^[\d\-\+]+$/);
	$length = "" unless($length =~ /\d+$/);
	$url = "" unless($length =~ /[\\,\#\&\%\+\.\/\:\=\?\@\w\s\~\-!<>]+$/);

	if($time ne ""){
		$ret = "LIRS" . "," . $time . "," . $lmd . "," . $lag . "," . $length . "," . $url . "," . $title . "," . $author . "," . $remote . ",";
		$ret .= $optional."," if($optional ne "");
		$ret .= "\n";
	}else{
		$ret = "LIRS" . ",0,0," . $lag . "," . $length . "," . $url . "," . $title . "," . $author . "," . $remote . ",";
		$ret .= $optional."," if($optional ne "");
		$ret .= "\n";
	}
	return $ret;
}


## compressLIRS
# ǻꤷLIRSե뤫顢žѤΰ̥եgzip(ǻ)Ǻޤ
# ΤȤLIRSեϤΤޤްݻޤ
# 1֤Ԥ0֤ޤ
sub compressLIRS{
	my ($obj, $gzip, $file) = @_;

	if(-e $file){
		if(-e "$file.gz"){
			unlink("$file.gz") || die "&LIRS\'cLIRS: $!\n";
		}
		copy($file, "$file.bak") || die "&LIRS\'cLIRS: $!\n";
#		system($gzip, $file, "$file.gz");
		system($gzip, $file);
		move("$file.bak", "$file") || die "&LIRS\'cLIRS: $!\n";

		return 1 if(-e "$file.gz" && -e $file);
	}
	return 0;
}


## extractLIRS
# ǻꤷgzipǰ̤줿LIRSեgzip(ǻ)ǻȤ褦Ÿޤ
# ⤷ꤷե뤬Ǥ¸ߤȤϡ񤭤ޤ
# 1֤Ԥ0֤ޤ
sub extractLIRS{
	my ($obj, $gzip, $file) = @_;

	my $fil = $file;
	$fil =~ s/.gz$//i;
	if(-e $fil){
		unlink("$fil") || die "&LIRS\'xLIRS: $!\n";
	}
	system($gzip, "-d", $file);
	return 1 if(-e $fil);
	return 0;
}


#### ̾Υ֥롼ȤƻȤ

## LIRS2list
# Υ⥸塼򥪥֥ȤȤƻȤʤȤ˸ƤӽФؿ
# ܺ٤ϡtolistפι໲ȡ
sub LIRS2list{
	my $a = shift;
	return &tolist("0", $a);
}


## list2LIRS
# Υ⥸塼򥪥֥ȤȤƻȤʤȤ˸ƤӽФؿ
# ܺ٤ϡtoLIRSפι໲ȡ
sub list2LIRS{
	my ($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional) = @_;
	return &toLIRS("0", $time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional);
}


## cLIRS
# Υ⥸塼򥪥֥ȤȤƻȤʤȤ˸ƤӽФؿ
# ܺ٤ϡcompressLIRSפι໲ȡ
sub cLIRS{
	my $gzip = shift;
	my $file = shift;
	return &compressLIRS("0", $gzip, $file);
}


## xLIRS
# Υ⥸塼򥪥֥ȤȤƻȤʤȤ˸ƤӽФؿ
# ܺ٤ϡextractLIRSפι໲ȡ
sub xLIRS{
	my $gzip = shift;
	my $file = shift;
	return &extractLIRS("0", $gzip, $file);
}


1;

