package nm::files;
# ֤ʤĤߤץ饤֥files.pm
# "NATSU-MICAN" Copyright (C) 1998-2000 hiya All Rights Reserved.

=head1 NAME

nm::files - ֤ʤĤߤץե饤֥

=head1 SYNOPSIS

use nm::files;
$Files = new nm::files;

=head1 DESCRIPTION

nm::filesϡʤĤߤǥեԤݤ˻Ȥ롼򽸤᤿⥸塼Ǥ

=head1 COPYRIGHT

Copyright (C) 2000 hiya All Rights Reserved.

=head1 AUTHOR

Ҥ(hiya@hauN.org)

=cut



##########

# 
require 5.004;
use strict;
use IO::Socket;
use IO::Select;

$nm::files::version = q(1.00);

##########

## new
# 󥹥󥹤롣
sub new{
	my $pkg = shift;
	my $self = bless {}, $pkg;
	return $self;
}


sub ver{
	return $nm::files::version;
}


=head1 FUNCTIONS

ʲϤΥ⥸塼˴ޤޤؿβǤ

=cut



##########

=head2 alldirs

alldirs
ǥ쥯ȥ겼Υե뤫ꤷޤեΥѥФ

ˡ
$Files->alldirs($directory[, $word]);

͡
եꥹ(顼ͤ)

⡧
ꤵ줿ǥ쥯ȥ۲Υ֥ǥ쥯ȥޤƤΥեΤʤ顢$wordǻꤷɤޤե֤ޤ
$word'*'ꤵƤ硢ƤΥȥ꡼֤ޤ(ɤȤʤ)
ͤμξǡ顼ƥȤλϥ顼֤ޤ
$wordɽѤǤޤ

Ϣ
Υ⥸塼dirs(), dircheck()ѤƤޤ

=cut

sub alldirs{
	my ($self, $DIR, $WORD) = @_;
	my (@chkdirs, @files);
	my $a;

	$WORD = '*' unless($WORD);

	$DIR =~ s%/$%%g;

	push(@chkdirs, "$DIR");
	for(;;){
		$a = shift(@chkdirs);
		last if($a eq "");

		push(@files, $self->dirs($a, $WORD));
		push(@chkdirs, $self->dircheck($a));
	}

	wantarray ? @files : join('', @files);
}



##########

=head2 dircheck

dircheck
ǥ쥯ȥ겼Υ֥ǥ쥯ȥΥꥹȤФ

ˡ
$Files->dircheck($directory);

͡
ǥ쥯ȥꥹ()

⡧
ꤵ줿ǥ쥯ȥ۲Υ֥ǥ쥯ȥ$directory/dirȸΥѥ֤ޤ

Ϣ
Υ⥸塼dirs(), dircheck()ѤƤޤ

=cut

sub dircheck{
	my ($self, $DIR) = @_;
	my @ret = ();
	my $a;

	opendir(CKDIR, "$DIR");
	while($a = readdir(CKDIR)){
		if(-d "$DIR/$a"){
			push(@ret, "$DIR/$a") unless($a =~ /^\.\.?$/);
		}
	}
	closedir(CKDIR);

	@ret;
}


##
# &dirs($dir, $word)
# ꤵ줿ǥ쥯ȥλꤵ줿ɤޤե$dir/fileȸΥѥ֤
# $word'*'ꤵƤ硢Υǥ쥯ȥƤΥȥ꡼֤
# ʤ֤ͤ˥ǥ쥯ȥϴޤޤʤ
sub dirs{
	my ($self, $DIR, $WORD) = @_;
	my @ret = ();
	my $a;

	opendir(CKDIR, "$DIR");
	while($a = readdir(CKDIR)){
		if($WORD eq "*"){
			push(@ret, "$DIR/$a") unless(-d "$DIR/$a");
		}else{
			if($a =~ /$WORD/){
				push(@ret, "$DIR/$a") unless(-d "$DIR/$a");
			}
		}
	}
	closedir(CKDIR);

	@ret;
}


##
# ե뤫鹹Ф
sub file_time{
	my ($self, $file) = @_;

	(stat($file))[9];
}


##
# ܥå󥯥ե뤫鹹Ф
sub lfile_time{
	my ($self, $file) = @_;

	(lstat($file))[9];
}


##
# ե뤫ե륵Ф
sub file_size{
	my ($self, $file) = @_;

	(stat($file))[7];
}


##
# եɤ߽Ф
sub read_file{
	my ($self, $targetfile, $os) = @_;

	if(-e "$targetfile"){
		if(open(TGT, "$targetfile")){
			flock(TGT, 2) if($os eq "unix");
			binmode TGT;
			my @read = <TGT>;
			flock(TGT, 8) if($os eq "unix");
			close(TGT);

			return wantarray ? @read : join('', @read);
		}
	}
	return undef;
}


##
# ե˽񤭽Ф
sub write_file{
	my ($self, $targetfile, $contents, $os) = @_;

	if(open(TGT, ">$targetfile")){
		flock(TGT, 2) if($os eq "unix");
		binmode TGT;
		print TGT $contents;
		flock(TGT, 8) if($os eq "unix");
		close(TGT);

		return 1;
	}
	return undef;
}


##
# եɵ
sub add_file{
	my ($self, $targetfile, $contents, $os) = @_;

	if(open(TGT, ">>$targetfile")){
		flock(TGT, 2) if($os eq "unix");
		binmode TGT;
		print TGT $contents;
		flock(TGT, 8) if($os eq "unix");
		close(TGT);

		return 1;
	}
	return undef;
}



1;

